#include "json.hpp"

namespace fcf{
namespace format{
namespace json{

  std::string adapt_json_cstr(const char* a_str){
    int state = 0; // 0 - code
                   // 1 - comment
                   // 2 - multyline comment
                   // 3 - string
                   // 4 - dquote string
    std::string res;
    int sc = 0;
    for (int i = 0; a_str[i]; ++i){
      char c = a_str[i];

      switch(state){
        case 0:
          if (c == '/' &&  a_str[i+1] == '/'){
            state = 1;
          } else if (c == '/' && a_str[i+1] == '*') {
            state = 2;
          } else if (c == '\''){
            res += '"';
            state = 3;
          } else if (c == '"'){
            res += c;
            state = 4;
          } else {
            res += c;
          }
          break;
        case 1:
          if (c == '\n'){
            res += c;
            state = 0;
          }
          break;
        case 2:
          if (c == '*' && a_str[i+1] == '/')
            state = 0;
          break;
        case 3:
          if (c == '\'' && (sc % 2 == 0)){
            res += '"';
            state = 0;
          } else {
            res += c;
          }
          break;
        case 4:
          if (c == '"' && (sc % 2 == 0))
            state = 0;
          res += c;
          break;
      }

      if (c == '\\')
        sc += 1;
      else
        sc = 0;
    }
    return res;    
  }

}
}
}